<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xml" indent="yes"/>
<!-- convert ctest output to junit format -->
<!--
Inspired by https://stackoverflow.com/questions/6329215/how-to-get-ctest-results-in-hudson-jenkins
Based on https://github.com/zanata/zanata-tests/blob/master/scripts/CTest2JUnit.xsl
Extended by providing total Start date, total time, total test stats
-->
	<xsl:template match="/Site">
          
        <xsl:if test="Testing">
            <xsl:variable name="StartDate"><xsl:value-of select="Testing/StartDateTime"/></xsl:variable>
            <xsl:variable name="DoTime"><xsl:value-of select="Testing/EndTestTime - Testing/StartTestTime"/></xsl:variable>
            <xsl:variable name="TotalTests"><xsl:value-of select="count(Testing/Test)"/></xsl:variable>
            <xsl:variable name="Skipped"><xsl:value-of select="count(Testing/Test[@Status='notrun'])"/></xsl:variable>
            <xsl:variable name="Disabled"><xsl:value-of select="count(Testing/Test/Results/Measurement[Value='Disabled'])"/></xsl:variable>
            <xsl:variable name="Failed"><xsl:value-of select="count(Testing/Test[@Status='failed'])"/></xsl:variable>

       		<testsuite time="{$DoTime}" timestamp="{$StartDate}" tests="{$TotalTests}" failures="{$Failed}" skipped="{$Skipped}" disabled="{$Disabled}">

			<xsl:variable name="BuildName"><xsl:value-of select="@BuildName"/></xsl:variable>
			<xsl:variable name="BuildStamp"><xsl:value-of select="@BuildStamp"/></xsl:variable>
			<xsl:variable name="Name"><xsl:value-of select="@Name"/></xsl:variable>
			<xsl:variable name="Generator"><xsl:value-of select="@Generator"/></xsl:variable>
			<xsl:variable name="CompilerName"><xsl:value-of select="@CompilerName"/></xsl:variable>
			<xsl:variable name="OSName"><xsl:value-of select="@OSName"/></xsl:variable>
			<xsl:variable name="Hostname"><xsl:value-of select="@Hostname"/></xsl:variable>
			<xsl:variable name="OSRelease"><xsl:value-of select="@OSRelease"/></xsl:variable>
			<xsl:variable name="OSVersion"><xsl:value-of select="@OSVersion"/></xsl:variable>
			<xsl:variable name="OSPlatform"><xsl:value-of select="@OSPlatform"/></xsl:variable>
			<xsl:variable name="Is64Bits"><xsl:value-of select="@Is64Bits"/></xsl:variable>
			<xsl:variable name="VendorString"><xsl:value-of select="@VendorString"/></xsl:variable>
			<xsl:variable name="VendorID"><xsl:value-of select="@VendorID"/></xsl:variable>
			<xsl:variable name="FamilyID"><xsl:value-of select="@FamilyID"/></xsl:variable>
			<xsl:variable name="ModelID"><xsl:value-of select="@ModelID"/></xsl:variable>
			<xsl:variable name="ProcessorCacheSize"><xsl:value-of select="@ProcessorCacheSize"/></xsl:variable>
			<xsl:variable name="NumberOfLogicalCPU"><xsl:value-of select="@NumberOfLogicalCPU"/></xsl:variable>
			<xsl:variable name="NumberOfPhysicalCPU"><xsl:value-of select="@NumberOfPhysicalCPU"/></xsl:variable>
			<xsl:variable name="TotalVirtualMemory"><xsl:value-of select="@TotalVirtualMemory"/></xsl:variable>
			<xsl:variable name="TotalPhysicalMemory"><xsl:value-of select="@TotalPhysicalMemory"/></xsl:variable>
			<xsl:variable name="LogicalProcessorsPerPhysical"><xsl:value-of select="@LogicalProcessorsPerPhysical"/></xsl:variable>
			<xsl:variable name="ProcessorClockFrequency"><xsl:value-of select="@ProcessorClockFrequency"/></xsl:variable>
			<properties>
				<property name="BuildName" value="{$BuildName} {$DoTime}" />
				<property name="BuildStamp" value="{$BuildStamp}" />
				<property name="Name" value="{$Name}" />
				<property name="Generator" value="{$Generator}" />
				<property name="CompilerName" value="{$CompilerName}" />
				<property name="OSName" value="{$OSName}" />
				<property name="Hostname" value="{$Hostname}" />
				<property name="OSRelease" value="{$OSRelease}" />
				<property name="OSVersion" value="{$OSVersion}" />
				<property name="OSPlatform" value="{$OSPlatform}" />
				<property name="Is64Bits" value="{$Is64Bits}" />
				<property name="VendorString" value="{$VendorString}" />
				<property name="VendorID" value="{$VendorID}" />
				<property name="FamilyID" value="{$FamilyID}" />
				<property name="ModelID" value="{$ModelID}" />
				<property name="ProcessorCacheSize" value="{$ProcessorCacheSize}" />
				<property name="NumberOfLogicalCPU" value="{$NumberOfLogicalCPU}" />
				<property name="NumberOfPhysicalCPU" value="{$NumberOfPhysicalCPU}" />
				<property name="TotalVirtualMemory" value="{$TotalVirtualMemory}" />
				<property name="TotalPhysicalMemory" value="{$TotalPhysicalMemory}" />
				<property name="LogicalProcessorsPerPhysical" value="{$LogicalProcessorsPerPhysical}" />
				<property name="ProcessorClockFrequency" value="{$ProcessorClockFrequency}" />
			</properties>
			<xsl:apply-templates select="Testing/Test"/>
			
			<system-out>
				BuildName: <xsl:value-of select="$BuildName" />
				BuildStamp: <xsl:value-of select="$BuildStamp" />
				Name: <xsl:value-of select="$Name" />
				Generator: <xsl:value-of select="$Generator" />
				CompilerName: <xsl:value-of select="$CompilerName" />
				OSName: <xsl:value-of select="$OSName" />
				Hostname: <xsl:value-of select="$Hostname" />
				OSRelease: <xsl:value-of select="$OSRelease" />
				OSVersion: <xsl:value-of select="$OSVersion" />
				OSPlatform: <xsl:value-of select="$OSPlatform" />
				Is64Bits: <xsl:value-of select="$Is64Bits" />
				VendorString: <xsl:value-of select="$VendorString" />
				VendorID: <xsl:value-of select="$VendorID" />
				FamilyID: <xsl:value-of select="$FamilyID" />
				ModelID: <xsl:value-of select="$ModelID" />
				ProcessorCacheSize: <xsl:value-of select="$ProcessorCacheSize" />
				NumberOfLogicalCPU: <xsl:value-of select="$NumberOfLogicalCPU" />
				NumberOfPhysicalCPU: <xsl:value-of select="$NumberOfPhysicalCPU" />
				TotalVirtualMemory: <xsl:value-of select="$TotalVirtualMemory" />
				TotalPhysicalMemory: <xsl:value-of select="$TotalPhysicalMemory" />
				LogicalProcessorsPerPhysical: <xsl:value-of select="$LogicalProcessorsPerPhysical" />
				ProcessorClockFrequency: <xsl:value-of select="$ProcessorClockFrequency" />
			</system-out>
		    </testsuite>
        </xsl:if>

        <xsl:if test="DynamicAnalysis">
            <xsl:variable name="StartDate"><xsl:value-of select="DynamicAnalysis/StartDateTime"/></xsl:variable>
            <xsl:variable name="DoTime"><xsl:value-of select="DynamicAnalysis/EndTestTime - DynamicAnalysis/StartTestTime"/></xsl:variable>
            <xsl:variable name="TotalTests"><xsl:value-of select="count(DynamicAnalysis/Test)"/></xsl:variable>
            <xsl:variable name="Skipped"><xsl:value-of select="count(DynamicAnalysis/Test[@Status='notrun'])"/></xsl:variable>
            <xsl:variable name="Disabled">0</xsl:variable>
            <xsl:variable name="Failed"><xsl:value-of select="count(DynamicAnalysis/Test[@Status='failed'])"/></xsl:variable>

       		<testsuite time="{$DoTime}" timestamp="{$StartDate}" tests="{$TotalTests}" failures="{$Failed}" skipped="{$Skipped}" disabled="{$Disabled}">

			<xsl:variable name="BuildName"><xsl:value-of select="@BuildName"/></xsl:variable>
			<xsl:variable name="BuildStamp"><xsl:value-of select="@BuildStamp"/></xsl:variable>
			<xsl:variable name="Name"><xsl:value-of select="@Name"/></xsl:variable>
			<xsl:variable name="Generator"><xsl:value-of select="@Generator"/></xsl:variable>
			<xsl:variable name="CompilerName"><xsl:value-of select="@CompilerName"/></xsl:variable>
			<xsl:variable name="OSName"><xsl:value-of select="@OSName"/></xsl:variable>
			<xsl:variable name="Hostname"><xsl:value-of select="@Hostname"/></xsl:variable>
			<xsl:variable name="OSRelease"><xsl:value-of select="@OSRelease"/></xsl:variable>
			<xsl:variable name="OSVersion"><xsl:value-of select="@OSVersion"/></xsl:variable>
			<xsl:variable name="OSPlatform"><xsl:value-of select="@OSPlatform"/></xsl:variable>
			<xsl:variable name="Is64Bits"><xsl:value-of select="@Is64Bits"/></xsl:variable>
			<xsl:variable name="VendorString"><xsl:value-of select="@VendorString"/></xsl:variable>
			<xsl:variable name="VendorID"><xsl:value-of select="@VendorID"/></xsl:variable>
			<xsl:variable name="FamilyID"><xsl:value-of select="@FamilyID"/></xsl:variable>
			<xsl:variable name="ModelID"><xsl:value-of select="@ModelID"/></xsl:variable>
			<xsl:variable name="ProcessorCacheSize"><xsl:value-of select="@ProcessorCacheSize"/></xsl:variable>
			<xsl:variable name="NumberOfLogicalCPU"><xsl:value-of select="@NumberOfLogicalCPU"/></xsl:variable>
			<xsl:variable name="NumberOfPhysicalCPU"><xsl:value-of select="@NumberOfPhysicalCPU"/></xsl:variable>
			<xsl:variable name="TotalVirtualMemory"><xsl:value-of select="@TotalVirtualMemory"/></xsl:variable>
			<xsl:variable name="TotalPhysicalMemory"><xsl:value-of select="@TotalPhysicalMemory"/></xsl:variable>
			<xsl:variable name="LogicalProcessorsPerPhysical"><xsl:value-of select="@LogicalProcessorsPerPhysical"/></xsl:variable>
			<xsl:variable name="ProcessorClockFrequency"><xsl:value-of select="@ProcessorClockFrequency"/></xsl:variable>
			<properties>
				<property name="BuildName" value="{$BuildName} {$DoTime}" />
				<property name="BuildStamp" value="{$BuildStamp}" />
				<property name="Name" value="{$Name}" />
				<property name="Generator" value="{$Generator}" />
				<property name="CompilerName" value="{$CompilerName}" />
				<property name="OSName" value="{$OSName}" />
				<property name="Hostname" value="{$Hostname}" />
				<property name="OSRelease" value="{$OSRelease}" />
				<property name="OSVersion" value="{$OSVersion}" />
				<property name="OSPlatform" value="{$OSPlatform}" />
				<property name="Is64Bits" value="{$Is64Bits}" />
				<property name="VendorString" value="{$VendorString}" />
				<property name="VendorID" value="{$VendorID}" />
				<property name="FamilyID" value="{$FamilyID}" />
				<property name="ModelID" value="{$ModelID}" />
				<property name="ProcessorCacheSize" value="{$ProcessorCacheSize}" />
				<property name="NumberOfLogicalCPU" value="{$NumberOfLogicalCPU}" />
				<property name="NumberOfPhysicalCPU" value="{$NumberOfPhysicalCPU}" />
				<property name="TotalVirtualMemory" value="{$TotalVirtualMemory}" />
				<property name="TotalPhysicalMemory" value="{$TotalPhysicalMemory}" />
				<property name="LogicalProcessorsPerPhysical" value="{$LogicalProcessorsPerPhysical}" />
				<property name="ProcessorClockFrequency" value="{$ProcessorClockFrequency}" />
			</properties>
			<xsl:apply-templates select="DynamicAnalysis/Test"/>
			
			<system-out>
				BuildName: <xsl:value-of select="$BuildName" />
				BuildStamp: <xsl:value-of select="$BuildStamp" />
				Name: <xsl:value-of select="$Name" />
				Generator: <xsl:value-of select="$Generator" />
				CompilerName: <xsl:value-of select="$CompilerName" />
				OSName: <xsl:value-of select="$OSName" />
				Hostname: <xsl:value-of select="$Hostname" />
				OSRelease: <xsl:value-of select="$OSRelease" />
				OSVersion: <xsl:value-of select="$OSVersion" />
				OSPlatform: <xsl:value-of select="$OSPlatform" />
				Is64Bits: <xsl:value-of select="$Is64Bits" />
				VendorString: <xsl:value-of select="$VendorString" />
				VendorID: <xsl:value-of select="$VendorID" />
				FamilyID: <xsl:value-of select="$FamilyID" />
				ModelID: <xsl:value-of select="$ModelID" />
				ProcessorCacheSize: <xsl:value-of select="$ProcessorCacheSize" />
				NumberOfLogicalCPU: <xsl:value-of select="$NumberOfLogicalCPU" />
				NumberOfPhysicalCPU: <xsl:value-of select="$NumberOfPhysicalCPU" />
				TotalVirtualMemory: <xsl:value-of select="$TotalVirtualMemory" />
				TotalPhysicalMemory: <xsl:value-of select="$TotalPhysicalMemory" />
				LogicalProcessorsPerPhysical: <xsl:value-of select="$LogicalProcessorsPerPhysical" />
				ProcessorClockFrequency: <xsl:value-of select="$ProcessorClockFrequency" />
			</system-out>
		    </testsuite>
        </xsl:if>
	</xsl:template>

    <xsl:template match="Testing/Test">
        <xsl:variable name="testcasename"><xsl:value-of select="Name"/></xsl:variable>
        <xsl:variable name="testclassname"><xsl:value-of select=" concat('this', substring(Path,2))"/></xsl:variable>
		<xsl:variable name="exectime">
			<xsl:for-each select="Results/NamedMeasurement">
				<xsl:if test="@name='Execution Time'">
					<xsl:value-of select="Value"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		
			<testcase name="{$testcasename}" classname="{$testclassname}" time="{$exectime}">
            <xsl:if test="@Status = 'passed'">
            <system-out><xsl:value-of select="Results/Measurement/Value/text()"/></system-out>
            </xsl:if>
            <xsl:if test="@Status = 'failed'">
				<xsl:variable name="failtype">
					<xsl:for-each select="Results/NamedMeasurement">
						<xsl:if test="@name = 'Exit Code'">
							<xsl:value-of select="Value"/>
						</xsl:if>
					</xsl:for-each>
				</xsl:variable>
				<xsl:variable name="failcode">
					<xsl:for-each select="Results/NamedMeasurement">
						<xsl:if test="@name = 'Exit Value'">
							<xsl:value-of select="Value"/>
						</xsl:if>
					</xsl:for-each>
				</xsl:variable>
                <failure message="{$failtype} ({$failcode})"><xsl:value-of select="Results/Measurement/Value/text()" /></failure>
            </xsl:if>
            <xsl:if test="@Status = 'notrun'">
                <skipped><xsl:value-of select="Results/Measurement/Value/text()" /></skipped>
            </xsl:if>
        </testcase>
    </xsl:template>

    <xsl:template match="DynamicAnalysis/Test">
        <xsl:variable name="testcasename"><xsl:value-of select="Name"/></xsl:variable>
        <xsl:variable name="testclassname"><xsl:value-of select=" concat('this', substring(Path,2))"/></xsl:variable>

        
			<testcase name="{$testcasename}" classname="{$testclassname}">
            <xsl:if test="@Status = 'passed'">
                <system-out><xsl:value-of select="Log/text()"/></system-out>
            </xsl:if>

            <xsl:if test="@Status = 'failed'">
                <failure><xsl:value-of select="Log/text()" /></failure>
            </xsl:if>

            <xsl:if test="@Status = 'notrun'">
                <skipped><xsl:value-of select="Log/text()" /></skipped>
            </xsl:if>


            </testcase>
    </xsl:template>

</xsl:stylesheet>

